#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const int N=1003;

struct P
{
	ll x;
	ll y;
	int IT;
};

int S[N];
vector<int> G[N];
vector<P> pd[N];
vector<pair<int,int>> res;

int calc_size(int v,int oj);
bool cmp1(P a, P b);
bool cmp2(P a, P b);
void calc_edges(int v,int oj,int oj_IT);

 int main()
 {
	int n;
	scanf("%d",&n);
	
	for(int i=1;i<n;i++)
	{
		int a,b;
		scanf("%d%d",&a,&b);
		G[a].push_back(b);
		G[b].push_back(a);
	}

	calc_size(1,1);

	for(int i=0;i<n;i++)
	{
		P tmp;
		scanf("%lld%lld",&tmp.x,&tmp.y);
		tmp.IT=i;
		pd[1].push_back(tmp);
	}

	calc_edges(1,1,-1);
	
	for(auto z : res) printf("%d %d\n",z.first,z.second); 
 }
//////////
 int calc_size(int v,int oj)
 {
	S[v]=1;

	for(auto z : G[v])
	{
		if(z==oj) continue;
		S[v]+=calc_size(z,v);
	}

	return S[v];
 }
/////////
 void calc_edges(int v,int oj,int oj_IT) 
 {
	sort(pd[v].begin(),pd[v].end(),cmp1);
	for(int i=1;i<(int)pd[v].size();i++) pd[v][i].x-=pd[v][0].x, pd[v][i].y-=pd[v][0].y;
	if((int)pd[v].size()>1) sort(pd[v].begin()+1,pd[v].end(),cmp2);
	for(int i=1;i<(int)pd[v].size();i++) pd[v][i].x+=pd[v][0].x, pd[v][i].y+=pd[v][0].y;

	if(oj_IT!=-1) res.push_back(make_pair(pd[v][0].IT,oj_IT));

	int l=1;
	for(auto z : G[v])
	{
		if(z==oj) continue;
		while(S[z]>0)
		{
			pd[z].push_back(pd[v][l]);
			l++;
			S[z]--;
		}

		calc_edges(z,v,pd[v][0].IT);
	}
 }
////////
 bool cmp1(P a,P b)
 {
	return make_pair(a.x,a.y)<make_pair(b.x,b.y);
 }
////////
 bool cmp2(P a,P b)
 {
	return a.x*b.y-a.y*b.x>0;
 }
