#include <bits/stdc++.h>
#define int long long
using namespace std;

const int MAXN = 4e5+3;

int compress(int x,int y){
	return (x* (MAXN+2)) + y;
}

vector<int> fau;
vector<int> siz;

int find(int x){
	if(fau[x] == x)
		return fau[x];
	fau[x] = find(fau[x]);
	return fau[x];
}

void unia(int x,int y){
	x = find(x);
	y = find(y);
	if(x == y)
		return;
	if(siz[x] < siz[y])
		swap(x,y);
	siz[x] += siz[y];
	siz[y] = 0;
	fau[y] = x;
}

void join(int x,int y,int x2,int y2){
	int a = compress(x,y);
	int b = compress(x2,y2);
	//cout<<"union "<<a<<" "<<b<<endl;
	unia(a,b);
}

vector<set<pair<int,int> > > prz;

const int SIZ = (1<<21);
int drzewo [100][2*SIZ];

void insertt(int x, int a, int b){
	//cout<<"insert "<<x<<" "<<a<<" "<<b<<endl;
	a += SIZ;
	b += SIZ+2;
	while(a != b && a+1 != b){
		if(a%2 == 0){
			drzewo[x][a+1]++;
		}
		if(b%2 == 1){
			drzewo[x][b-1]++;
		}
		a/=2;
		b/=2;
	}
}

int query(int x,int a){
	int res = 0;
	a += SIZ+1;
	while(a > 0){
		res += drzewo[x][a];
		a/=2;
	}
	return res;
}



 main(){
	ios::sync_with_stdio(false);
	fau.resize(106*(MAXN+2));
	siz.resize(106*(MAXN+2),1);
	for(int i=0;i<fau.size();i++)
		fau[i] = i;
	
	prz.resize(100);
	for(int i=0;i<100;i++){
		for(int j=0;j<MAXN;j++)
			prz[i].insert(make_pair(j,j));
	}
	
	int T;
	cin >> T;
	while(T--){
		int ty,x,y,x2,y2;
		cin >> ty >> x >> y >> x2 >> y2;
		x++; y++; x2++; y2++;
		if(ty == 0){
			if(x2 < x) swap(x2,x);
			if(y2 < y) swap(y2,y);
		}
		//cout<<find(compress(4,4))<<" "<<find(compress(7,7))<<endl;
		if(ty == 1){
			if(query(x,y) > 0 && query(x2,y2) > 0 && find(compress(x,y)) == find(compress(x2,y2)))
				cout<<1<<"\n";
			else
				cout<<"0\n";
			//cout<<find(compress(x,y))<<" ? "<<find(compress(x2,y2))<<endl;
			//cout<<(find(compress(x,y) == find(compress(x2,y2)) ? 1 : 0));
		}
		else{
			for(int i=x;i<=x2;i++){
				insertt(i,y,y2);
				auto it = prz[i].upper_bound(make_pair(y,1e8));
				it--;
				auto startVal = *it;
				//cout<<startVal.first<<" "<<startVal.second<<" ";
				while(it->first <= y2){

					auto cur = *it;
					auto cp = it;
					it--;
					//cout<<(it == cp)<<endl;
					prz[i].erase(cp);
					
					if(i+1 <= x2 || query(i+1,cur.first) > 0)
						join(i,cur.first,i+1,cur.first);
					if(i+1 <= x2 || query(i+1,cur.second) > 0)	
						join(i,cur.second,i+1,cur.second);
					
					if(i-1 >= x || query(i-1,cur.first) > 0){
						join(i,cur.first,i-1,cur.first);
					}
					if(i-1 >= x || query(i-1,cur.second) > 0)	
						join(i,cur.second,i-1,cur.second);
						
					if(cur.first-1 >= y || query(i,cur.first-1) > 0)
						join(i,cur.first,i,cur.first-1);
					if(cur.second+1 <= y2 || query(i,cur.second+1) > 0){
						join(i,cur.second,i,cur.second+1);
					}
					it++;
				}
				
				prz[i].insert(make_pair(startVal.first,it->first-1));
			}
		}
	}
}

